Package org.eclipse.m2m.atl.emftvm.util

# Class LazyOrderedSet.InsertAtOrderedSet<E>

java.lang.Object
org.eclipse.m2m.atl.emftvm.util.LazyCollection<E>
org.eclipse.m2m.atl.emftvm.util.LazyOrderedSet<E>
org.eclipse.m2m.atl.emftvm.util.LazyOrderedSet.NonCachingOrderedSet<E>
org.eclipse.m2m.atl.emftvm.util.LazyOrderedSet.AppendOrderedSet<E>
org.eclipse.m2m.atl.emftvm.util.LazyOrderedSet.InsertAtOrderedSet<E>

Type Parameters:
  `E` - the collection element type

All Implemented Interfaces:
  `Iterable<E>`, `Collection<E>`, `List<E>`, `Set<E>`

Enclosing class:
  LazyOrderedSet<E>

public static class LazyOrderedSet.InsertAtOrderedSet<E> extends LazyOrderedSet.AppendOrderedSet<E>
`LazyOrderedSet` that inserts an object into the underlying `LazyOrderedSet`, except when it already occurs in the underlying `LazyOrderedSet`. List index starts at 0.

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`class`
`LazyOrderedSet.InsertAtOrderedSet.InsertAtOrderedSetIterator`
`Iterator` that appends an object to the underlying collection, except when it already occurs in the underlying collection.
`class`
`LazyOrderedSet.InsertAtOrderedSet.InsertAtOrderedSetListIterator`
`Iterator` that appends an object to the underlying collection, except when it already occurs in the underlying collection.

## Nested classes/interfaces inherited from class org.eclipse.m2m.atl.emftvm.util.LazyOrderedSet.AppendOrderedSet

`LazyOrderedSet.AppendOrderedSet.AppendOrderedSetIterator, LazyOrderedSet.AppendOrderedSet.AppendOrderedSetListIterator`

## Nested classes/interfaces inherited from class org.eclipse.m2m.atl.emftvm.util.LazyOrderedSet

`LazyOrderedSet.AppendOrderedSet<E>, LazyOrderedSet.ExcludingOrderedSet<E>, LazyOrderedSet.InsertAtOrderedSet<E>, LazyOrderedSet.IntegerRangeOrderedSet, LazyOrderedSet.LongRangeOrderedSet, LazyOrderedSet.NonCachingOrderedSet<E>, LazyOrderedSet.PrependOrderedSet<E>, LazyOrderedSet.ReverseOrderedSet<E>, LazyOrderedSet.SubOrderedSet<E>`

## Nested classes/interfaces inherited from class org.eclipse.m2m.atl.emftvm.util.LazyCollection

`LazyCollection.AppendIterator, LazyCollection.CachingIterator, LazyCollection.CachingSetIterator, LazyCollection.CollectIterator<T>, LazyCollection.ExcludingIterator, LazyCollection.FilterIterator, LazyCollection.FlattenIterator, LazyCollection.FlattenSetIterator, LazyCollection.IntegerRangeListIterator, LazyCollection.IntersectionIterator, LazyCollection.IteratorToListIterator, LazyCollection.LongRangeListIterator, LazyCollection.ReadOnlyIterator<E>, LazyCollection.ReadOnlyListIterator<E>, LazyCollection.RejectIterator, LazyCollection.ReverseIterator, LazyCollection.ReverseListIterator, LazyCollection.SelectIterator, LazyCollection.SubListIterator, LazyCollection.SubListListIterator, LazyCollection.SubtractionIterator, LazyCollection.UnionIterator, LazyCollection.UnionSetIterator, LazyCollection.WrappedIterator, LazyCollection.WrappedListIterator`

## Field Summary

Fields
Modifier and Type
Field
Description
`protected final int`
`index`

### Fields inherited from class org.eclipse.m2m.atl.emftvm.util.LazyOrderedSet.AppendOrderedSet

`containsObject, containsObjectSet, object`

### Fields inherited from class org.eclipse.m2m.atl.emftvm.util.LazyCollection

`cache, dataSource, occurrences`

## Constructor Summary

Constructors
Constructor
Description
`InsertAtOrderedSet(E object, int index, LazyOrderedSet<E> dataSource)`
Creates a new `LazyOrderedSet.InsertAtOrderedSet`.

## Method Summary

Modifier and Type
Method
Description
`E`
`first()`
Returns the first element in self.
`E`
`get(int index)`
`int`
`indexOf(Object o)`
`Iterator<E>`
`iterator()`
`E`
`last()`
Returns the last element in self.
`ListIterator<E>`
`listIterator()`
`ListIterator<E>`
`listIterator(int index)`

### Methods inherited from class org.eclipse.m2m.atl.emftvm.util.LazyOrderedSet.AppendOrderedSet

`contains, count, isEmpty, size`

### Methods inherited from class org.eclipse.m2m.atl.emftvm.util.LazyOrderedSet.NonCachingOrderedSet

`createCache`

### Methods inherited from class org.eclipse.m2m.atl.emftvm.util.LazyOrderedSet

`add, addAll, append, asOrderedSet, asString, at, collect, equals, excluding, excludingAll, flatten, hashCode, including, including, includingAll, includingAll, includingRange, indexOf2, insertAt, intersection, intersection, intersection, lastIndexOf, lastIndexOf2, prepend, reject, remove, reverse, select, set, sortedBy, spliterator, subList, subSequence, subtract, subtract, symmetricDifference, union, union, union, union`

### Methods inherited from class org.eclipse.m2m.atl.emftvm.util.LazyCollection

`add, addAll, any, appendElements, asBag, asSequence, asSet, clear, containsAll, containsAny, excludes, excludesAll, exists, exists2, forAll, forAll2, includes, includesAll, isUnique, iterate, mappedBy, mappedBySingle, max, min, notEmpty, one, product, remove, removeAll, retainAll, sum, toArray, toArray, toString`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface java.util.Collection

`parallelStream, removeIf, stream, toArray`

### Methods inherited from interface java.lang.Iterable

`forEach`

### Methods inherited from interface java.util.List

`add, addAll, clear, containsAll, remove, removeAll, replaceAll, retainAll, sort, toArray, toArray`

### Methods inherited from interface java.util.Set

`add, addAll, clear, containsAll, remove, removeAll, retainAll, toArray, toArray`

## Field Details

### index

protected final int index

## Constructor Details

### InsertAtOrderedSet

public InsertAtOrderedSet(E object, int index, LazyOrderedSet<E> dataSource)
Creates a new `LazyOrderedSet.InsertAtOrderedSet`.

Parameters:
  `object` - the object to insert
  `index` - the insertion index
  `dataSource` - the underlying collection

## Method Details

### iterator

public Iterator<E> iterator()

Specified by:
  `iterator` in interface `Collection<E>`
Specified by:
  `iterator` in interface `Iterable<E>`
Specified by:
  `iterator` in interface `List<E>`
Specified by:
  `iterator` in interface `Set<E>`
Overrides:
  `iterator` in class `LazyOrderedSet.AppendOrderedSet<E>`

### first

public E first()
Returns the first element in self.

Overrides:
  `first` in class `LazyOrderedSet.AppendOrderedSet<E>`
Returns:
  The first element in self.
See Also:
  - `LazyOrderedSet.first()`

### last

public E last()
Returns the last element in self.

Overrides:
  `last` in class `LazyOrderedSet.AppendOrderedSet<E>`
Returns:
  The last element in self.

### get

public E get(int index)

Specified by:
  `get` in interface `List<E>`
Overrides:
  `get` in class `LazyOrderedSet.AppendOrderedSet<E>`

### indexOf

public int indexOf(Object o)

Specified by:
  `indexOf` in interface `List<E>`
Overrides:
  `indexOf` in class `LazyOrderedSet.AppendOrderedSet<E>`

### listIterator

public ListIterator<E> listIterator()

Specified by:
  `listIterator` in interface `List<E>`
Overrides:
  `listIterator` in class `LazyOrderedSet.AppendOrderedSet<E>`

### listIterator

public ListIterator<E> listIterator(int index)

Specified by:
  `listIterator` in interface `List<E>`
Overrides:
  `listIterator` in class `LazyOrderedSet.AppendOrderedSet<E>`